#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

    /* Definicija tipa. */

typedef struct _element {
    char osobno_ime[13];
    int broj_cipela;
    struct _element *next;
} element;

    /* Funkcija ispisi. */

void ispisi(element *first, int a) {
    element *pom = first;

    printf("Osobna imena elementa liste s brojem cipele > %d:\n", a);
    while (pom != NULL) {
        if (pom->broj_cipela > a)
            printf("  osobno ime = %s\n" , pom->osobno_ime);
        pom = pom->next;
    }
    return;
}

    /* Funkcija brisi. */
    /* Prvo pomocna funkcija za provjeru zavrsava li ime samoglasnikom. */

int kraj_samogl(const char s[]) {
    int z = tolower( s[strlen(s)-1] );
    return z == 'a' || z == 'e' || z == 'i' || z == 'o' || z == 'u';
}

element *brisi(element *first) {
    element *pom = first, *preth = NULL, *obrisi;

    while (pom != NULL) {
        if (kraj_samogl(pom->osobno_ime)) {
            obrisi = pom;
            if (pom == first)  // ekvivalentno je preth == NULL
                first = pom->next;  // = first->next
            else
                preth->next = pom->next;  // = preth->next->next
            pom = pom->next;
            free(obrisi);
        }
        else {
            preth = pom;
            pom = pom->next;  // = preth->next
        }
    }

/*
   Alternativna realizacija u dva koraka, bez pokazivaca pom:
     - PRVO obrisemo takve elemente na pocetku liste (ako ih ima).
     - Ako je nesto ostalo u listi, ZATIM ih brisemo u ostatku liste
       (naravno, ako ih ima).

    while (first != NULL && kraj_samogl(first->osobno_ime)) {
        obrisi = first;
        first = first->next;
        free(obrisi);
    }
    if (first != NULL) {
        preth = first;
        while (preth->next != NULL)
            if (kraj_samogl(preth->next->osobno_ime)) {
                obrisi = preth->next;
                preth->next = preth->next->next;
                free(obrisi);
            }
            else
                preth = preth->next;
    }
*/

    return first;
}

    /* Funkcija dodaj. */

element *dodaj(element *first, char *osobno_ime, int broj_cipela) {
    element *novi;

    if ((novi = (element*) malloc(sizeof(element))) == NULL) {
        fprintf(stderr, "Alokacija za element nije uspjela.\n");
        exit(EXIT_FAILURE);
    }

    strcpy(novi->osobno_ime, osobno_ime);
    novi->broj_cipela = broj_cipela;
    novi->next = first;

    return novi;
}
