#include <stdio.h>
#include <stdlib.h>
#include <string.h>

    /* Definicija tipa. */

typedef struct _element {
    int kucni_broj;
    char ime_ulice[24];
    struct _element *next;
} element;

    /* Funkcija ispisi. */

void ispisi(element *first, const char s[]) {
    element *pom = first;

    printf("Kucni brojevi elementa liste s imenom ulice %s:\n", s);
    while (pom != NULL) {
        if (strcmp(pom->ime_ulice, s) == 0)
            printf("  kucni broj = %d\n" , pom->kucni_broj);
        pom = pom->next;
    }
    return;
}

    /* Funkcija brisi. */
    /* Prvo pomocna funkcija za aritmeticku sredinu svih kucnih brojeva. */

double arit_sred(element *first) {
    element *pom = first;
    int broj = 0, suma = 0;
    while (pom != NULL) {
        ++broj;
        suma += pom->kucni_broj;
        pom = pom->next;
    }
    return broj > 0 ? suma/broj : 0.0 ;
}

element *brisi(element *first) {
    element *pom = first, *preth = NULL, *obrisi;
    double as;

    as = arit_sred(first);

    while (pom != NULL) {
        if (pom->kucni_broj > as) {
            obrisi = pom;
            if (pom == first)  // ekvivalentno je preth == NULL
                first = pom->next;  // = first->next
            else
                preth->next = pom->next;  // = preth->next->next
            pom = pom->next;
            free(obrisi);

                /* Prekid while petlje cim obrisemo prvog. */
            break;
        }
        else {
            preth = pom;
            pom = pom->next;  // = preth->next
        }
    }

/*
   Alternativna realizacija u if-then-else, bez pokazivaca pom:
     - ako je takav element na pocetku liste - obrisemo ga,
     - u protivnom, trazimo prvi takav element u ostatku liste,
       i obrisemo ga (naravno, ako ga ima).

    if (first == NULL) return NULL;
    if (first->kucni_broj > as) {
        obrisi = first;
        first = first->next;
        free(obrisi);
    }
    else {
        preth = first;
        while (preth->next != NULL && preth->next->kucni_broj <= as)
            preth = preth->next;
        if (preth->next != NULL) {
            obrisi = preth->next;
            preth->next = preth->next->next;
            free(obrisi);
        }
    }
*/

    return first;
}

    /* Funkcija dodaj. */

element *dodaj(element *first, int kucni_broj, char *ime_ulice) {
    element *novi, *pom = first;

    if ((novi = (element*) malloc(sizeof(element))) == NULL) {
        fprintf(stderr, "Alokacija za element nije uspjela.\n");
        exit(EXIT_FAILURE);
    }

    novi->kucni_broj = kucni_broj;
    strcpy(novi->ime_ulice, ime_ulice);
    novi->next = NULL;

    if (first == NULL) return novi;
    while (pom->next != NULL)
        pom = pom->next;
    pom->next = novi;

    return first;
}
