#include <stdio.h>
#include <stdlib.h>
#include <string.h>

  /***** (a) Definicija tipa turnir. *****/

    /* 1. nacin:
       prvo definiramo tip strukture igrac_t za jednog igraca,
       a onda turnir ima polje takvih struktura. */

/*
typedef struct {
    char ime_igraca[31];
    double zarada;
} igrac_t;

typedef struct {
    char ime_turnira[31];
    igrac_t igrac[72];
} turnir;
*/

    /* 2. nacin:
       spojimo sve u jedan tip za turnir, tako da tip strukture za jednog
       igraca definiramo kao tip za clan strukture, a onda, za clan
       navedemo polje takvih struktura. */
    /* Ime strukture _igrac za jednog igraca nam treba samo kod
       zamjene igraca u poredaj. Inace se smije ispustiti. */

typedef struct {
    char ime_turnira[31];
    struct _igrac {
        char ime_igraca[31];
        double zarada;
    } igrac[72];
} turnir;

  /***** (b) Funkcija poredaj *****/

turnir poredaj(turnir t)
{
    int i, j, i_max;

        /* Za 1. nacin definicije tipa, imamo posebni tip za igraca. */
/*
    igrac_t tmp;
*/
        /* Za 2. nacin, treba navesti ime strukture kao tip za igraca. */
    struct _igrac tmp;

        /* Sortiranje trazenjem ektrema. */

    for (i = 0; i < 71; ++i) {
        i_max = i;
        for (j = i + 1; j < 72; ++j)
            if (t.igrac[j].zarada > t.igrac[i_max].zarada)
                i_max = j;

            /* Zamjena cijelih igraca. */

        if (i_max > i) {
            tmp = t.igrac[i];
            t.igrac[i] = t.igrac[i_max];
            t.igrac[i_max] = tmp;
        }
    }
    return t;
}

  /***** (c) Funkcija zarada *****/

double zarada(char *ime_igraca, char *ime_datoteke)
{
    FILE *fp;
    turnir t;
    double suma = 0.0;
    int i;

        /* Otvori datoteku s provjerom. */

    if ((fp = fopen(ime_datoteke, "rb")) == NULL) {
        fprintf(stderr, "Ne mogu otvoriti datoteku %s!\n", ime_datoteke);
        exit(EXIT_FAILURE);  // ili samo return;
    }

        /* Prolaz kroz cijelu datoteku i provjera svakog turnira. */

    while (fread(&t, sizeof(turnir), 1, fp) == 1) {
        for (i = 0; i < 72; ++i) {
            if (strcmp(ime_igraca, t.igrac[i].ime_igraca) == 0) {
                suma += t.igrac[i].zarada;

                    /* Uz pretpostavku da je igrac naveden samo jednom,
                       onda moze i donji break - za prekid for petlje. */
                break;
            }
        }
    }

    fclose(fp);
    return suma;
}

  /***** (d) Funkcija uredi *****/

void uredi(FILE *fp)
{
    turnir t;

        /* Postavi se na pocetak datoteke, za slucaj da nismo tamo. */

    rewind(fp);  // moze i fseek(fp, 0L, SEEK_SET);

        /* Prolaz kroz cijelu datoteku i uredjenje svakog turnira. */

    while (fread(&t, sizeof(turnir), 1, fp) == 1) {
        t = poredaj(t);

            /* Pomak unatrag za jedan turnir i pisanje. */

        fseek(fp, -sizeof(turnir), SEEK_CUR);
        fwrite(&t, sizeof(turnir), 1, fp);
    }

    return;
}

  /***** Test program *****/

int main(int argc, char *argv[])
{
    FILE *fp;

    if (argc != 3) {
        fprintf(stderr, "Greska, nema imena datoteke i igraca!\n");
        exit(EXIT_FAILURE);
    }

        /* Uzmimo da je argv[1] = ime datoteke, argv[2] = ime igraca. */

    printf("Zarada igraca %s na turnirima u datoteci %s je %g\n",
           argv[2], argv[1], zarada(argv[2], argv[1]));

        /* Otvori datoteku za citanje i pisanje, prije poziva uredi. */

    if ((fp = fopen(argv[1], "r+b")) == NULL) {
        fprintf(stderr, "Ne mogu otvoriti datoteku %s!\n", argv[1]);
        exit(EXIT_FAILURE);
    }

    uredi(fp);
    fclose(fp);

    return EXIT_SUCCESS;
}
